#include <bits/stdc++.h>

using namespace std;

int main()
{
    ios_base::sync_with_stdio(false);cin.tie(NULL);cout.tie(NULL);
    long long i,n,m,t,nzd,mod;
    cin>>t;
    while(t--)
    {
        bool want=true;
        cin>>n>>m;
        vector<long long> A(n),B(m),R(n-1);
        for(i=0;i<n;i++)cin>>A[i];
        for(i=0;i<m;i++)cin>>B[i];
        sort(A.begin(),A.end());
        for(i=0;i<n-1;i++)R[i]=A[i+1]-A[i];
        nzd=R[0];
        for(i=1;i<n-1;i++)nzd=__gcd(nzd,R[i]);
        mod=A[0]%nzd;
        for(i=0;i<m;i++)
        {
            if(B[i]%nzd==mod)
            {
                want=false;
                break;
            }
        }
        if(want)cout<<1<<endl;
        else cout<<0<<endl;
    }
    return 0;
}